--- old/usr/src/uts/common/inet/ip/ipclassifier.c	2015-08-09 12:47:50.320403790 +0300
+++ new/usr/src/uts/common/inet/ip/ipclassifier.c	2015-08-09 12:47:50.336451308 +0300
@@ -2722,3 +2722,29 @@
 	return (1);
 }
 #endif
+
+conn_pid_node_list_hdr_t *
+conn_get_pid_list(conn_t *connp)
+{
+	conn_pid_node_list_hdr_t	*cph;
+
+	if (connp->conn_upper_handle != NULL) {
+		return (*connp->conn_upcalls->su_get_sock_pid_list)
+			(connp->conn_upper_handle);
+	} else if (!IPCL_IS_NONSTR(connp) && connp->conn_rq != NULL &&
+			connp->conn_rq->q_stream != NULL) {
+		return (sh_get_pid_list(connp->conn_rq->q_stream));
+	}
+
+	/* return an empty header */
+	cph = kmem_zalloc(sizeof (conn_pid_node_list_hdr_t), KM_SLEEP);
+	cph->cph_magic = CONN_PID_NODE_LIST_HDR_MAGIC;
+	cph->cph_contents = CONN_PID_NODE_LIST_HDR_NON;
+	cph->cph_pn_cnt = 0;
+	cph->cph_tot_size = sizeof (conn_pid_node_list_hdr_t);
+	cph->cph_flags = 0;
+	cph->cph_optional1 = 0;
+	cph->cph_optional2 = 0;
+
+	return (cph);
+}
